/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Account, EncodedAccount, FetchAccountConfig, FetchAccountsConfig, MaybeAccount, MaybeEncodedAccount, fetchEncodedAccount, fetchEncodedAccounts } from '@solana/accounts';
import { Address } from '@solana/addresses';
import { Codec, Decoder, Encoder, Option, OptionOrNullable } from '@solana/codecs';
import { MetadataSeeds } from '../pdas';
import { Collection, CollectionArgs, CollectionDetails, CollectionDetailsArgs, Creator, CreatorArgs, Key, ProgrammableConfig, ProgrammableConfigArgs, TokenStandard, TokenStandardArgs, Uses, UsesArgs } from '../types';
export type Metadata<TAddress extends string = string> = Account<MetadataAccountData, TAddress>;
export type MaybeMetadata<TAddress extends string = string> = MaybeAccount<MetadataAccountData, TAddress>;
export type MetadataAccountData = {
    key: Key;
    updateAuthority: Address;
    mint: Address;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Option<Array<Creator>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    editionNonce: Option<number>;
    tokenStandard: Option<TokenStandard>;
    collection: Option<Collection>;
    uses: Option<Uses>;
    collectionDetails: Option<CollectionDetails>;
    programmableConfig: Option<ProgrammableConfig>;
};
export type MetadataAccountDataArgs = {
    updateAuthority: Address;
    mint: Address;
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: OptionOrNullable<Array<CreatorArgs>>;
    primarySaleHappened: boolean;
    isMutable: boolean;
    editionNonce: OptionOrNullable<number>;
    tokenStandard: OptionOrNullable<TokenStandardArgs>;
    collection: OptionOrNullable<CollectionArgs>;
    uses: OptionOrNullable<UsesArgs>;
    collectionDetails: OptionOrNullable<CollectionDetailsArgs>;
    programmableConfig: OptionOrNullable<ProgrammableConfigArgs>;
};
export declare function getMetadataAccountDataEncoder(): Encoder<MetadataAccountDataArgs>;
export declare function getMetadataAccountDataDecoder(): Decoder<MetadataAccountData>;
export declare function getMetadataAccountDataCodec(): Codec<MetadataAccountDataArgs, MetadataAccountData>;
export declare function decodeMetadata<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): Metadata<TAddress>;
export declare function decodeMetadata<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeMetadata<TAddress>;
export declare function fetchMetadata<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<Metadata<TAddress>>;
export declare function fetchMaybeMetadata<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeMetadata<TAddress>>;
export declare function fetchAllMetadata(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<Metadata[]>;
export declare function fetchAllMaybeMetadata(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeMetadata[]>;
export declare function fetchMetadataFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: MetadataSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<Metadata>;
export declare function fetchMaybeMetadataFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: MetadataSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeMetadata>;
//# sourceMappingURL=metadata.d.ts.map