/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Account, EncodedAccount, FetchAccountConfig, FetchAccountsConfig, MaybeAccount, MaybeEncodedAccount, fetchEncodedAccount, fetchEncodedAccounts } from '@solana/accounts';
import { Address } from '@solana/addresses';
import { Codec, Decoder, Encoder, Option, OptionOrNullable } from '@solana/codecs';
import { TokenRecordSeeds } from '../pdas';
import { Key, TokenDelegateRole, TokenDelegateRoleArgs, TokenState, TokenStateArgs } from '../types';
export type TokenRecord<TAddress extends string = string> = Account<TokenRecordAccountData, TAddress>;
export type MaybeTokenRecord<TAddress extends string = string> = MaybeAccount<TokenRecordAccountData, TAddress>;
export type TokenRecordAccountData = {
    key: Key;
    bump: number;
    state: TokenState;
    ruleSetRevision: Option<bigint>;
    delegate: Option<Address>;
    delegateRole: Option<TokenDelegateRole>;
    lockedTransfer: Option<Address>;
};
export type TokenRecordAccountDataArgs = {
    bump: number;
    state: TokenStateArgs;
    ruleSetRevision: OptionOrNullable<number | bigint>;
    delegate: OptionOrNullable<Address>;
    delegateRole: OptionOrNullable<TokenDelegateRoleArgs>;
    lockedTransfer: OptionOrNullable<Address>;
};
export declare function getTokenRecordAccountDataEncoder(): Encoder<TokenRecordAccountDataArgs>;
export declare function getTokenRecordAccountDataDecoder(): Decoder<TokenRecordAccountData>;
export declare function getTokenRecordAccountDataCodec(): Codec<TokenRecordAccountDataArgs, TokenRecordAccountData>;
export declare function decodeTokenRecord<TAddress extends string = string>(encodedAccount: EncodedAccount<TAddress>): TokenRecord<TAddress>;
export declare function decodeTokenRecord<TAddress extends string = string>(encodedAccount: MaybeEncodedAccount<TAddress>): MaybeTokenRecord<TAddress>;
export declare function fetchTokenRecord<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<TokenRecord<TAddress>>;
export declare function fetchMaybeTokenRecord<TAddress extends string = string>(rpc: Parameters<typeof fetchEncodedAccount>[0], address: Address<TAddress>, config?: FetchAccountConfig): Promise<MaybeTokenRecord<TAddress>>;
export declare function fetchAllTokenRecord(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<TokenRecord[]>;
export declare function fetchAllMaybeTokenRecord(rpc: Parameters<typeof fetchEncodedAccounts>[0], addresses: Array<Address>, config?: FetchAccountsConfig): Promise<MaybeTokenRecord[]>;
export declare function getTokenRecordSize(): number;
export declare function fetchTokenRecordFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: TokenRecordSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<TokenRecord>;
export declare function fetchMaybeTokenRecordFromSeeds(rpc: Parameters<typeof fetchEncodedAccount>[0], seeds: TokenRecordSeeds, config?: FetchAccountConfig & {
    programAddress?: Address;
}): Promise<MaybeTokenRecord>;
//# sourceMappingURL=tokenRecord.d.ts.map