/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Address } from '@solana/addresses';
import { Codec, Decoder, Encoder } from '@solana/codecs';
import { IAccountMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, WritableAccount, WritableSignerAccount } from '@solana/instructions';
import { IAccountSignerMeta, TransactionSigner } from '@solana/signers';
export type CloseEscrowAccountInstruction<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountEscrow extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TRemainingAccounts extends Array<IAccountMeta<string>> = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEscrow extends string ? WritableAccount<TAccountEscrow> : TAccountEscrow,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountTokenAccount extends string ? ReadonlyAccount<TAccountTokenAccount> : TAccountTokenAccount,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    ...TRemainingAccounts
]>;
export type CloseEscrowAccountInstructionWithSigners<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountEscrow extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TRemainingAccounts extends Array<IAccountMeta<string>> = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEscrow extends string ? WritableAccount<TAccountEscrow> : TAccountEscrow,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountTokenAccount extends string ? ReadonlyAccount<TAccountTokenAccount> : TAccountTokenAccount,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    ...TRemainingAccounts
]>;
export type CloseEscrowAccountInstructionData = {
    discriminator: number;
};
export type CloseEscrowAccountInstructionDataArgs = {};
export declare function getCloseEscrowAccountInstructionDataEncoder(): Encoder<CloseEscrowAccountInstructionDataArgs>;
export declare function getCloseEscrowAccountInstructionDataDecoder(): Decoder<CloseEscrowAccountInstructionData>;
export declare function getCloseEscrowAccountInstructionDataCodec(): Codec<CloseEscrowAccountInstructionDataArgs, CloseEscrowAccountInstructionData>;
export type CloseEscrowAccountAsyncInput<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata?: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition?: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: Address<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
};
export type CloseEscrowAccountAsyncInputWithSigners<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata?: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition?: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: TransactionSigner<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
};
export declare function getCloseEscrowAccountInstructionAsync<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CloseEscrowAccountAsyncInputWithSigners<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>): Promise<CloseEscrowAccountInstructionWithSigners<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>>;
export declare function getCloseEscrowAccountInstructionAsync<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CloseEscrowAccountAsyncInput<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>): Promise<CloseEscrowAccountInstruction<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>>;
export type CloseEscrowAccountInput<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: Address<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
};
export type CloseEscrowAccountInputWithSigners<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: TransactionSigner<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
};
export declare function getCloseEscrowAccountInstruction<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CloseEscrowAccountInputWithSigners<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>): CloseEscrowAccountInstructionWithSigners<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>;
export declare function getCloseEscrowAccountInstruction<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CloseEscrowAccountInput<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>): CloseEscrowAccountInstruction<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions>;
export declare function getCloseEscrowAccountInstructionRaw<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountEscrow extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TRemainingAccounts extends Array<IAccountMeta<string>> = []>(accounts: {
    escrow: TAccountEscrow extends string ? Address<TAccountEscrow> : TAccountEscrow;
    metadata: TAccountMetadata extends string ? Address<TAccountMetadata> : TAccountMetadata;
    mint: TAccountMint extends string ? Address<TAccountMint> : TAccountMint;
    tokenAccount: TAccountTokenAccount extends string ? Address<TAccountTokenAccount> : TAccountTokenAccount;
    edition: TAccountEdition extends string ? Address<TAccountEdition> : TAccountEdition;
    payer: TAccountPayer extends string ? Address<TAccountPayer> : TAccountPayer;
    systemProgram?: TAccountSystemProgram extends string ? Address<TAccountSystemProgram> : TAccountSystemProgram;
    sysvarInstructions?: TAccountSysvarInstructions extends string ? Address<TAccountSysvarInstructions> : TAccountSysvarInstructions;
}, programAddress?: Address<TProgram>, remainingAccounts?: TRemainingAccounts): CloseEscrowAccountInstruction<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TRemainingAccounts>;
export type ParsedCloseEscrowAccountInstruction<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Escrow account */
        escrow: TAccountMetas[0];
        /** Metadata account */
        metadata: TAccountMetas[1];
        /** Mint account */
        mint: TAccountMetas[2];
        /** Token account */
        tokenAccount: TAccountMetas[3];
        /** Edition account */
        edition: TAccountMetas[4];
        /** Wallet paying for the transaction and new account */
        payer: TAccountMetas[5];
        /** System program */
        systemProgram: TAccountMetas[6];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[7];
    };
    data: CloseEscrowAccountInstructionData;
};
export declare function parseCloseEscrowAccountInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCloseEscrowAccountInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=closeEscrowAccount.d.ts.map