/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Address } from '@solana/addresses';
import { Codec, Decoder, Encoder } from '@solana/codecs';
import { IAccountMeta, IInstruction, IInstructionWithAccounts, IInstructionWithData, ReadonlyAccount, ReadonlySignerAccount, WritableAccount, WritableSignerAccount } from '@solana/instructions';
import { IAccountSignerMeta, TransactionSigner } from '@solana/signers';
export type CreateEscrowAccountInstruction<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountEscrow extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountAuthority extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends Array<IAccountMeta<string>> = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEscrow extends string ? WritableAccount<TAccountEscrow> : TAccountEscrow,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountTokenAccount extends string ? ReadonlyAccount<TAccountTokenAccount> : TAccountTokenAccount,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    ...(TAccountAuthority extends undefined ? [] : [
        TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> : TAccountAuthority
    ]),
    ...TRemainingAccounts
]>;
export type CreateEscrowAccountInstructionWithSigners<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountEscrow extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountAuthority extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends Array<IAccountMeta<string>> = []> = IInstruction<TProgram> & IInstructionWithData<Uint8Array> & IInstructionWithAccounts<[
    TAccountEscrow extends string ? WritableAccount<TAccountEscrow> : TAccountEscrow,
    TAccountMetadata extends string ? WritableAccount<TAccountMetadata> : TAccountMetadata,
    TAccountMint extends string ? ReadonlyAccount<TAccountMint> : TAccountMint,
    TAccountTokenAccount extends string ? ReadonlyAccount<TAccountTokenAccount> : TAccountTokenAccount,
    TAccountEdition extends string ? ReadonlyAccount<TAccountEdition> : TAccountEdition,
    TAccountPayer extends string ? WritableSignerAccount<TAccountPayer> & IAccountSignerMeta<TAccountPayer> : TAccountPayer,
    TAccountSystemProgram extends string ? ReadonlyAccount<TAccountSystemProgram> : TAccountSystemProgram,
    TAccountSysvarInstructions extends string ? ReadonlyAccount<TAccountSysvarInstructions> : TAccountSysvarInstructions,
    ...(TAccountAuthority extends undefined ? [] : [
        TAccountAuthority extends string ? ReadonlySignerAccount<TAccountAuthority> & IAccountSignerMeta<TAccountAuthority> : TAccountAuthority
    ]),
    ...TRemainingAccounts
]>;
export type CreateEscrowAccountInstructionData = {
    discriminator: number;
};
export type CreateEscrowAccountInstructionDataArgs = {};
export declare function getCreateEscrowAccountInstructionDataEncoder(): Encoder<CreateEscrowAccountInstructionDataArgs>;
export declare function getCreateEscrowAccountInstructionDataDecoder(): Decoder<CreateEscrowAccountInstructionData>;
export declare function getCreateEscrowAccountInstructionDataCodec(): Codec<CreateEscrowAccountInstructionDataArgs, CreateEscrowAccountInstructionData>;
export type CreateEscrowAccountAsyncInput<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata?: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account of the token */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition?: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: Address<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** Authority/creator of the escrow account */
    authority?: Address<TAccountAuthority>;
};
export type CreateEscrowAccountAsyncInputWithSigners<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata?: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account of the token */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition?: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: TransactionSigner<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** Authority/creator of the escrow account */
    authority?: TransactionSigner<TAccountAuthority>;
};
export declare function getCreateEscrowAccountInstructionAsync<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CreateEscrowAccountAsyncInputWithSigners<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>): Promise<CreateEscrowAccountInstructionWithSigners<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>>;
export declare function getCreateEscrowAccountInstructionAsync<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CreateEscrowAccountAsyncInput<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>): Promise<CreateEscrowAccountInstruction<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>>;
export type CreateEscrowAccountInput<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account of the token */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: Address<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** Authority/creator of the escrow account */
    authority?: Address<TAccountAuthority>;
};
export type CreateEscrowAccountInputWithSigners<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string> = {
    /** Escrow account */
    escrow: Address<TAccountEscrow>;
    /** Metadata account */
    metadata: Address<TAccountMetadata>;
    /** Mint account */
    mint: Address<TAccountMint>;
    /** Token account of the token */
    tokenAccount: Address<TAccountTokenAccount>;
    /** Edition account */
    edition: Address<TAccountEdition>;
    /** Wallet paying for the transaction and new account */
    payer: TransactionSigner<TAccountPayer>;
    /** System program */
    systemProgram?: Address<TAccountSystemProgram>;
    /** Instructions sysvar account */
    sysvarInstructions?: Address<TAccountSysvarInstructions>;
    /** Authority/creator of the escrow account */
    authority?: TransactionSigner<TAccountAuthority>;
};
export declare function getCreateEscrowAccountInstruction<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CreateEscrowAccountInputWithSigners<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>): CreateEscrowAccountInstructionWithSigners<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>;
export declare function getCreateEscrowAccountInstruction<TAccountEscrow extends string, TAccountMetadata extends string, TAccountMint extends string, TAccountTokenAccount extends string, TAccountEdition extends string, TAccountPayer extends string, TAccountSystemProgram extends string, TAccountSysvarInstructions extends string, TAccountAuthority extends string, TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'>(input: CreateEscrowAccountInput<TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>): CreateEscrowAccountInstruction<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority>;
export declare function getCreateEscrowAccountInstructionRaw<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountEscrow extends string | IAccountMeta<string> = string, TAccountMetadata extends string | IAccountMeta<string> = string, TAccountMint extends string | IAccountMeta<string> = string, TAccountTokenAccount extends string | IAccountMeta<string> = string, TAccountEdition extends string | IAccountMeta<string> = string, TAccountPayer extends string | IAccountMeta<string> = string, TAccountSystemProgram extends string | IAccountMeta<string> = '11111111111111111111111111111111', TAccountSysvarInstructions extends string | IAccountMeta<string> = 'Sysvar1nstructions1111111111111111111111111', TAccountAuthority extends string | IAccountMeta<string> | undefined = undefined, TRemainingAccounts extends Array<IAccountMeta<string>> = []>(accounts: {
    escrow: TAccountEscrow extends string ? Address<TAccountEscrow> : TAccountEscrow;
    metadata: TAccountMetadata extends string ? Address<TAccountMetadata> : TAccountMetadata;
    mint: TAccountMint extends string ? Address<TAccountMint> : TAccountMint;
    tokenAccount: TAccountTokenAccount extends string ? Address<TAccountTokenAccount> : TAccountTokenAccount;
    edition: TAccountEdition extends string ? Address<TAccountEdition> : TAccountEdition;
    payer: TAccountPayer extends string ? Address<TAccountPayer> : TAccountPayer;
    systemProgram?: TAccountSystemProgram extends string ? Address<TAccountSystemProgram> : TAccountSystemProgram;
    sysvarInstructions?: TAccountSysvarInstructions extends string ? Address<TAccountSysvarInstructions> : TAccountSysvarInstructions;
    authority?: TAccountAuthority extends string ? Address<TAccountAuthority> : TAccountAuthority;
}, programAddress?: Address<TProgram>, remainingAccounts?: TRemainingAccounts): CreateEscrowAccountInstruction<TProgram, TAccountEscrow, TAccountMetadata, TAccountMint, TAccountTokenAccount, TAccountEdition, TAccountPayer, TAccountSystemProgram, TAccountSysvarInstructions, TAccountAuthority, TRemainingAccounts>;
export type ParsedCreateEscrowAccountInstruction<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s', TAccountMetas extends readonly IAccountMeta[] = readonly IAccountMeta[]> = {
    programAddress: Address<TProgram>;
    accounts: {
        /** Escrow account */
        escrow: TAccountMetas[0];
        /** Metadata account */
        metadata: TAccountMetas[1];
        /** Mint account */
        mint: TAccountMetas[2];
        /** Token account of the token */
        tokenAccount: TAccountMetas[3];
        /** Edition account */
        edition: TAccountMetas[4];
        /** Wallet paying for the transaction and new account */
        payer: TAccountMetas[5];
        /** System program */
        systemProgram: TAccountMetas[6];
        /** Instructions sysvar account */
        sysvarInstructions: TAccountMetas[7];
        /** Authority/creator of the escrow account */
        authority?: TAccountMetas[8] | undefined;
    };
    data: CreateEscrowAccountInstructionData;
};
export declare function parseCreateEscrowAccountInstruction<TProgram extends string, TAccountMetas extends readonly IAccountMeta[]>(instruction: IInstruction<TProgram> & IInstructionWithAccounts<TAccountMetas> & IInstructionWithData<Uint8Array>): ParsedCreateEscrowAccountInstruction<TProgram, TAccountMetas>;
//# sourceMappingURL=createEscrowAccount.d.ts.map