/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
import { Address } from '@solana/addresses';
import { Program, ProgramWithErrors } from '@solana/programs';
import { MplTokenMetadataProgramError, MplTokenMetadataProgramErrorCode } from '../errors';
import { ParsedApproveCollectionAuthorityInstruction, ParsedApproveUseAuthorityInstruction, ParsedBubblegumSetCollectionSizeInstruction, ParsedBurnEditionNftInstruction, ParsedBurnNftInstruction, ParsedBurnV1Instruction, ParsedCloseEscrowAccountInstruction, ParsedCollectInstruction, ParsedConvertMasterEditionV1ToV2Instruction, ParsedCreateEscrowAccountInstruction, ParsedCreateMasterEditionV3Instruction, ParsedCreateMetadataAccountV3Instruction, ParsedCreateV1Instruction, ParsedDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstruction, ParsedFreezeDelegatedAccountInstruction, ParsedLockV1Instruction, ParsedMigrateInstruction, ParsedMintNewEditionFromMasterEditionViaTokenInstruction, ParsedMintNewEditionFromMasterEditionViaVaultProxyInstruction, ParsedMintV1Instruction, ParsedPrintV1Instruction, ParsedPuffMetadataInstruction, ParsedRemoveCreatorVerificationInstruction, ParsedSetAndVerifyCollectionInstruction, ParsedSetAndVerifySizedCollectionItemInstruction, ParsedSetCollectionSizeInstruction, ParsedSetTokenStandardInstruction, ParsedSignMetadataInstruction, ParsedThawDelegatedAccountInstruction, ParsedTransferOutOfEscrowInstruction, ParsedTransferV1Instruction, ParsedUnlockV1Instruction, ParsedUnverifyCollectionInstruction, ParsedUnverifyCollectionV1Instruction, ParsedUnverifyCreatorV1Instruction, ParsedUnverifySizedCollectionItemInstruction, ParsedUseV1Instruction, ParsedUtilizeInstruction, ParsedVerifyCollectionInstruction, ParsedVerifyCollectionV1Instruction, ParsedVerifyCreatorV1Instruction, ParsedVerifySizedCollectionItemInstruction } from '../instructions';
export declare const MPL_TOKEN_METADATA_PROGRAM_ADDRESS: Address<"metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s">;
export type MplTokenMetadataProgram = Program<'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'> & ProgramWithErrors<MplTokenMetadataProgramErrorCode, MplTokenMetadataProgramError>;
export declare function getMplTokenMetadataProgram(): MplTokenMetadataProgram;
export declare enum MplTokenMetadataAccount {
    CollectionAuthorityRecord = 0,
    MetadataDelegateRecord = 1,
    Edition = 2,
    EditionMarker = 3,
    EditionMarkerV2 = 4,
    TokenOwnedEscrow = 5,
    MasterEdition = 6,
    Metadata = 7,
    TokenRecord = 8,
    UseAuthorityRecord = 9
}
export declare function identifyMplTokenMetadataAccount(account: {
    data: Uint8Array;
} | Uint8Array): MplTokenMetadataAccount;
export declare enum MplTokenMetadataInstruction {
    DeprecatedMintNewEditionFromMasterEditionViaPrintingToken = 0,
    SignMetadata = 1,
    MintNewEditionFromMasterEditionViaToken = 2,
    ConvertMasterEditionV1ToV2 = 3,
    MintNewEditionFromMasterEditionViaVaultProxy = 4,
    PuffMetadata = 5,
    CreateMasterEditionV3 = 6,
    VerifyCollection = 7,
    Utilize = 8,
    ApproveUseAuthority = 9,
    UnverifyCollection = 10,
    ApproveCollectionAuthority = 11,
    SetAndVerifyCollection = 12,
    FreezeDelegatedAccount = 13,
    ThawDelegatedAccount = 14,
    RemoveCreatorVerification = 15,
    BurnNft = 16,
    VerifySizedCollectionItem = 17,
    UnverifySizedCollectionItem = 18,
    SetAndVerifySizedCollectionItem = 19,
    CreateMetadataAccountV3 = 20,
    SetCollectionSize = 21,
    SetTokenStandard = 22,
    BubblegumSetCollectionSize = 23,
    BurnEditionNft = 24,
    CreateEscrowAccount = 25,
    CloseEscrowAccount = 26,
    TransferOutOfEscrow = 27,
    BurnV1 = 28,
    CreateV1 = 29,
    MintV1 = 30,
    LockV1 = 31,
    UnlockV1 = 32,
    Migrate = 33,
    TransferV1 = 34,
    UseV1 = 35,
    VerifyCreatorV1 = 36,
    VerifyCollectionV1 = 37,
    UnverifyCreatorV1 = 38,
    UnverifyCollectionV1 = 39,
    Collect = 40,
    PrintV1 = 41
}
export declare function identifyMplTokenMetadataInstruction(instruction: {
    data: Uint8Array;
} | Uint8Array): MplTokenMetadataInstruction;
export type ParsedMplTokenMetadataInstruction<TProgram extends string = 'metaqbxxUerdq28cj1RbAWkYQm3ybzjb6a8bt518x1s'> = ({
    instructionType: MplTokenMetadataInstruction.DeprecatedMintNewEditionFromMasterEditionViaPrintingToken;
} & ParsedDeprecatedMintNewEditionFromMasterEditionViaPrintingTokenInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.SignMetadata;
} & ParsedSignMetadataInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.MintNewEditionFromMasterEditionViaToken;
} & ParsedMintNewEditionFromMasterEditionViaTokenInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.ConvertMasterEditionV1ToV2;
} & ParsedConvertMasterEditionV1ToV2Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.MintNewEditionFromMasterEditionViaVaultProxy;
} & ParsedMintNewEditionFromMasterEditionViaVaultProxyInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.PuffMetadata;
} & ParsedPuffMetadataInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.CreateMasterEditionV3;
} & ParsedCreateMasterEditionV3Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.VerifyCollection;
} & ParsedVerifyCollectionInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.Utilize;
} & ParsedUtilizeInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.ApproveUseAuthority;
} & ParsedApproveUseAuthorityInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.UnverifyCollection;
} & ParsedUnverifyCollectionInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.ApproveCollectionAuthority;
} & ParsedApproveCollectionAuthorityInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.SetAndVerifyCollection;
} & ParsedSetAndVerifyCollectionInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.FreezeDelegatedAccount;
} & ParsedFreezeDelegatedAccountInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.ThawDelegatedAccount;
} & ParsedThawDelegatedAccountInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.RemoveCreatorVerification;
} & ParsedRemoveCreatorVerificationInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.BurnNft;
} & ParsedBurnNftInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.VerifySizedCollectionItem;
} & ParsedVerifySizedCollectionItemInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.UnverifySizedCollectionItem;
} & ParsedUnverifySizedCollectionItemInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.SetAndVerifySizedCollectionItem;
} & ParsedSetAndVerifySizedCollectionItemInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.CreateMetadataAccountV3;
} & ParsedCreateMetadataAccountV3Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.SetCollectionSize;
} & ParsedSetCollectionSizeInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.SetTokenStandard;
} & ParsedSetTokenStandardInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.BubblegumSetCollectionSize;
} & ParsedBubblegumSetCollectionSizeInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.BurnEditionNft;
} & ParsedBurnEditionNftInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.CreateEscrowAccount;
} & ParsedCreateEscrowAccountInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.CloseEscrowAccount;
} & ParsedCloseEscrowAccountInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.TransferOutOfEscrow;
} & ParsedTransferOutOfEscrowInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.BurnV1;
} & ParsedBurnV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.CreateV1;
} & ParsedCreateV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.MintV1;
} & ParsedMintV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.LockV1;
} & ParsedLockV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.UnlockV1;
} & ParsedUnlockV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.Migrate;
} & ParsedMigrateInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.TransferV1;
} & ParsedTransferV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.UseV1;
} & ParsedUseV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.VerifyCreatorV1;
} & ParsedVerifyCreatorV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.VerifyCollectionV1;
} & ParsedVerifyCollectionV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.UnverifyCreatorV1;
} & ParsedUnverifyCreatorV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.UnverifyCollectionV1;
} & ParsedUnverifyCollectionV1Instruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.Collect;
} & ParsedCollectInstruction<TProgram>) | ({
    instructionType: MplTokenMetadataInstruction.PrintV1;
} & ParsedPrintV1Instruction<TProgram>);
//# sourceMappingURL=mplTokenMetadata.d.ts.map