import { Address } from '@solana/addresses';
import { KeyPairSigner } from '@solana/signers';
import { OptionOrNullable } from '@solana/codecs';
import { Client } from '@tensor-foundation/test-helpers';
import { TokenStandard, Creator, Collection, Uses, CollectionDetails, PrintSupplyArgs } from '../generated';
export interface NftData {
    name: string;
    symbol: string;
    uri: string;
    sellerFeeBasisPoints: number;
    creators: Creator[];
    primarySaleHappened?: boolean;
    isMutable?: boolean;
    tokenStandard?: TokenStandard;
    collection?: Collection;
    uses?: Uses;
    collectionDetails?: CollectionDetails;
    ruleSet?: Address;
    decimals?: number;
    printSupply?: OptionOrNullable<PrintSupplyArgs>;
    isCollection?: boolean;
}
export type Nft = {
    mint: Address;
    metadata: Address;
    masterEdition: Address;
    token: Address;
    tokenRecord?: Address;
};
export declare const createDefaultNft: (client: Client, authority: KeyPairSigner<string>, owner: KeyPairSigner, payer: KeyPairSigner | null) => Promise<Nft>;
export declare const createDefaultpNft: (client: Client, authority: KeyPairSigner<string>, owner: KeyPairSigner, payer: KeyPairSigner | null) => Promise<Nft>;
export declare const createDefaultToken22pNft: (client: Client, authority: KeyPairSigner<string>, owner: KeyPairSigner, payer: KeyPairSigner | null) => Promise<Nft>;
export interface MintNftAccounts {
    authority: KeyPairSigner;
    owner: KeyPairSigner;
    payer: KeyPairSigner | null;
    mint?: KeyPairSigner;
    tokenProgramId?: Address;
}
export declare const createDefaultToken22Nft: (client: Client, authority: KeyPairSigner, owner: KeyPairSigner, payer: KeyPairSigner | null) => Promise<Nft>;
export declare const mintNft: (client: Client, accounts: MintNftAccounts, data: NftData) => Promise<Nft>;
//# sourceMappingURL=mint.d.ts.map